#include "StdAfx.h"
#include "NoteMemberInfoActorEvent.h"


CNoteMemberInfoActorEvent::CNoteMemberInfoActorEvent(SendNoteMananger *pManager)
:m_pSendNoteManager(pManager),m_bRegister(FALSE)
{

	m_NoteInfoTrid.clear();
}

CNoteMemberInfoActorEvent::~CNoteMemberInfoActorEvent(void)
{
	if (m_bRegister)
	{
		g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
		//g_pMessengerActor->UnRegisterObserver(this);
	}
}

bool CNoteMemberInfoActorEvent::OnGTWASActor_ResponseGetEmployeeInfo( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::map<trid_t, NoteInfo>::const_iterator iter = m_NoteInfoTrid.find(trid);
	if (iter != m_NoteInfoTrid.end())
	{
		std::vector<ReceiverInfo> receiverVector;

		NoteInfo noteInfo = iter->second;
		
		for (size_t i = 0; i < list.nSize; i++) 
		{
			const NE_MEMBER_DATA &sMemberInfo  = list.pList[i];
			ReceiverInfo receiverInfo;
			receiverInfo.strID = sMemberInfo.strUserId.c_str();
			receiverInfo.strName = sMemberInfo.strName.c_str();
			receiverVector.push_back(receiverInfo);
		}

		m_pSendNoteManager->MakeMemoSendDlg(receiverVector,noteInfo.strTitle,noteInfo.strContent);
		return false;
	}

	return true;
}

bool CNoteMemberInfoActorEvent::RequestSendNote( const std::vector<ReceiverInfo> receiverVector ,CString strTitle,CString strContent )
{
	NoteInfo noteInfo;
	noteInfo.strTitle = strTitle;
	noteInfo.strContent = strContent;

	CString  strIDs(_T(""));
	std::vector<ReceiverInfo>::const_iterator iter = receiverVector.begin();
	for(;iter != receiverVector.end(); ++ iter)
	{
		ReceiverInfo ri = *iter;
		strIDs.AppendFormat(L"%s|", ri.strID.c_str());
	}

	if (strIDs.IsEmpty() == FALSE)
	{
		trid_t trid;
		g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(strIDs, GetLanguageStringUnicode(), reitSingleTrans, &trid);
		m_NoteInfoTrid.insert(make_pair(trid,noteInfo));

	}

	return true;
}


